#include "CrossPlatform.h"
#include "Gamefield.h"
#include "Player.h"
#include <iostream>
#include <string>
#include <deque>
#include <fstream>
#include <sstream>

std::deque<std::string> g_levels;

void DoLevel(const std::string& filename)
{
    Gamefield gamefield;
    Player player;
    if(!gamefield.Init(filename, player))
    {
        return;
    }
    //initial render
    gamefield.Display(player);
    while(gamefield.Cells[player.Y][player.X] != Gamefield::EXIT_CHAR)
    {
        //wait for input
        char c = CrossPlatform::ReadKey();
        switch(c)
        {
        case 'R': //restart
        case 'r':
            g_levels.push_front(filename);
            return;
        case 'Q': //quit
        case 'q':
            g_levels.clear();
            return;
        case 'A':
        case 'a':
            gamefield.TryMove(player, -1, 0);
            break;
        case 'D':
        case 'd':
            gamefield.TryMove(player, 1, 0);
            break;
        case 'W':
        case 'w':
            gamefield.TryMove(player, 0, -1);
            break;
        case 'S':
        case 's':
            gamefield.TryMove(player, 0, 1);
            break;
        default:
            break;
        }
        //render
        gamefield.Display(player);
    }
}

int main(int argc, char** argv)
{
    int i = 0;
    while(true)
    {
        std::stringstream ss;
        ss<<"levels/"<<++i<<".txt";
        if(std::ifstream(ss.str().c_str()).good())
        {
            g_levels.push_back(ss.str());
        }
        else
        {
            break;
        }
    }
    while(!g_levels.empty())
    {
        DoLevel(g_levels.front());
        //might've been emptied due to exit.
        if(g_levels.empty())
        {
            std::cout<<"Bye!"<<std::endl;
            CrossPlatform::ReadKey(); //press any key
            return 0;
        }
        g_levels.pop_front();
    }
    std::cout<<"Gratz, you won!"<<std::endl;
    CrossPlatform::ReadKey(); //press any key

    return 0;
}
